function param = estwarp_condens(frm, tmpl, param, opt)
% function param = estwarp_condens(frm, tmpl, param, opt)
%

%% Copyright (C) Jongwoo Lim and David Ross.
%% All rights reserved.

n = opt.numsample;
sz = opt.tmplsize;
param.param = repmat(affparam2geom(param.est(:)), [1,n]);

%prediction
param.param = param.param + randn(6,n).*repmat(opt.affsig(:),[1,n]); 

% show the predicted region by particle filtering
boundary = zeros(4,n);
tmp = zeros(4,1); % x,y, width, height
tmp_conv = [1,0,-0.5,0; 1,0,0.5,0; 0,1,0,-0.5;0,1,0,0.5];
for i=1:n
    tmp(1:2) = param.param(1:2,i);
    tmp(3) = param.param(3,i)*opt.tmplsize(2);
    tmp(4) = param.param(5,i)*tmp(3);    
    boundary(:,i) = tmp_conv*tmp;    
end
left = min(boundary(1,:));
right = max(boundary(2,:));
top = min(boundary(3,:));
down = max(boundary(4,:));
bkBox = [left, right, top, down];
bkBox = round(bkBox);
param.bkBox = bkBox;

wimgs = warpimg(frm, affparam2mat(param.param), sz);

%% use sparse coding 
% calculate the sparse representation of all the candidates at the same
A = SparseRepresentImGPU(wimgs, opt, tmpl.D);  %represent each candidate with the sparse coefficient vector. The size is 1024*

%% use the learned logistic function
% tic;
P = 1 ./ (1 + exp(-(tmpl.w'*A+tmpl.b))); %tracker
Po = 0;
P_sum = opt.conf * P + (1 - opt.conf)*Po;
param.conf = P_sum';
% toc;
% 
% %%%%%%%%%%%%%%%%%%%find the tracking result%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[~,maxidx] = max(param.conf);
param.est = affparam2mat(param.param(:,maxidx)); %
param.wimg = wimgs(:,:,maxidx);
param.obser = A(:,maxidx);



